Index: libmpc/trunk/win32/libcommon.vcproj
===================================================================
--- libmpc/trunk/win32/libcommon.vcproj	(revision 328)
+++ libmpc/trunk/win32/libcommon.vcproj	(revision 329)
@@ -39,8 +39,7 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				PreprocessorDefinitions="_WIN32;_DEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE"
+				PreprocessorDefinitions="_WIN32;WIN32;_DEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE"
 				ExceptionHandling="0"
 				BasicRuntimeChecks="3"
-				SmallerTypeCheck="true"
 				RuntimeLibrary="1"
 				BrowseInformation="1"
@@ -105,5 +104,5 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				PreprocessorDefinitions="WIN32;NDEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE"
+				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE"
 				StringPooling="true"
 				ExceptionHandling="0"
Index: libmpc/trunk/win32/libmpcenc.vcproj
===================================================================
--- libmpc/trunk/win32/libmpcenc.vcproj	(revision 328)
+++ libmpc/trunk/win32/libmpcenc.vcproj	(revision 329)
@@ -40,5 +40,5 @@
 				Optimization="0"
 				AdditionalIncludeDirectories="../include"
-				PreprocessorDefinitions="WIN32;_WIN32;_DEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE"
+				PreprocessorDefinitions="_WIN32;WIN32;_DEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE"
 				ExceptionHandling="0"
 				BasicRuntimeChecks="3"
@@ -105,5 +105,6 @@
 				Name="VCCLCompilerTool"
 				AdditionalIncludeDirectories="../include"
-				PreprocessorDefinitions="WIN32;_WIN32;NDEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE"
+				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE"
+				StringPooling="true"
 				ExceptionHandling="0"
 				BufferSecurityCheck="false"
Index: libmpc/trunk/win32/libmpcpsy.vcproj
===================================================================
--- libmpc/trunk/win32/libmpcpsy.vcproj	(revision 328)
+++ libmpc/trunk/win32/libmpcpsy.vcproj	(revision 329)
@@ -40,5 +40,5 @@
 				Optimization="0"
 				AdditionalIncludeDirectories="../include"
-				PreprocessorDefinitions="WIN32;_WIN32;_DEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE"
+				PreprocessorDefinitions="_WIN32;WIN32;_DEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE"
 				ExceptionHandling="0"
 				BasicRuntimeChecks="3"
@@ -105,5 +105,5 @@
 				Name="VCCLCompilerTool"
 				AdditionalIncludeDirectories="../include"
-				PreprocessorDefinitions="WIN32;_WIN32;NDEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE"
+				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE"
 				ExceptionHandling="0"
 				BufferSecurityCheck="false"
@@ -112,5 +112,4 @@
 				WarningLevel="3"
 				Detect64BitPortabilityProblems="true"
-				DebugInformationFormat="3"
 				CompileAs="1"
 			/>
Index: libmpc/trunk/win32/libwavformat.vcproj
===================================================================
--- libmpc/trunk/win32/libwavformat.vcproj	(revision 328)
+++ libmpc/trunk/win32/libwavformat.vcproj	(revision 329)
@@ -108,8 +108,8 @@
 				Name="VCCLCompilerTool"
 				PreprocessorDefinitions="WIN32;NDEBUG;_LIB"
+				StringPooling="true"
 				ExceptionHandling="0"
-				RuntimeLibrary="0"
 				BufferSecurityCheck="false"
-				UsePrecompiledHeader="0"
+				EnableFunctionLevelLinking="true"
 				WarningLevel="3"
 				Detect64BitPortabilityProblems="true"
Index: libmpc/trunk/win32/mpcdec.vcproj
===================================================================
--- libmpc/trunk/win32/mpcdec.vcproj	(revision 328)
+++ libmpc/trunk/win32/mpcdec.vcproj	(revision 329)
@@ -41,5 +41,5 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories="../include,../libwavformat"
+				AdditionalIncludeDirectories="../include,../libwavformat,../win32"
 				PreprocessorDefinitions="WIN32;_DEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE"
 				ExceptionHandling="0"
@@ -124,9 +124,10 @@
 			<Tool
 				Name="VCCLCompilerTool"
-				AdditionalIncludeDirectories="../include,../libwavformat"
+				AdditionalIncludeDirectories="../include,../libwavformat,../win32"
 				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE"
+				StringPooling="true"
 				ExceptionHandling="0"
 				BufferSecurityCheck="false"
-				UsePrecompiledHeader="0"
+				EnableFunctionLevelLinking="true"
 				WarningLevel="3"
 				Detect64BitPortabilityProblems="true"
Index: libmpc/trunk/win32/mpcenc.vcproj
===================================================================
--- libmpc/trunk/win32/mpcenc.vcproj	(revision 328)
+++ libmpc/trunk/win32/mpcenc.vcproj	(revision 329)
@@ -42,5 +42,5 @@
 				Optimization="0"
 				AdditionalIncludeDirectories="../include;../libmpcenc;../libmpcpsy"
-				PreprocessorDefinitions="WIN32;_WIN32;_DEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE;MPP_ENCODER;CVD_FASTLOG;FAST_MATH"
+				PreprocessorDefinitions="_WIN32;WIN32;_DEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE;MPP_ENCODER;CVD_FASTLOG;FAST_MATH"
 				ExceptionHandling="0"
 				BasicRuntimeChecks="3"
@@ -63,5 +63,5 @@
 			<Tool
 				Name="VCLinkerTool"
-				AdditionalDependencies="winmm.lib User32.lib"
+				AdditionalDependencies="winmm.lib"
 				OutputFile="$(OutDir)\$(ProjectName)_d.exe"
 				GenerateManifest="false"
@@ -125,7 +125,6 @@
 				Name="VCCLCompilerTool"
 				AdditionalIncludeDirectories="../include;../libmpcenc;../libmpcpsy"
-				PreprocessorDefinitions="WIN32;_WIN32;NDEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE;MPP_ENCODER"
+				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE;MPP_ENCODER"
 				ExceptionHandling="0"
-				RuntimeLibrary="0"
 				BufferSecurityCheck="false"
 				EnableFunctionLevelLinking="true"
@@ -146,5 +145,5 @@
 			<Tool
 				Name="VCLinkerTool"
-				AdditionalDependencies="winmm.lib User32.lib"
+				AdditionalDependencies="winmm.lib"
 				GenerateManifest="false"
 				SubSystem="1"