Index: libmpc/trunk/win32/libmpcenc.vcproj
===================================================================
--- libmpc/trunk/win32/libmpcenc.vcproj	(revision 342)
+++ libmpc/trunk/win32/libmpcenc.vcproj	(revision 343)
@@ -2,7 +2,8 @@
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="8,00"
+	Version="8.00"
 	Name="libmpcenc"
 	ProjectGUID="{44EC1266-D2EE-47B8-ACFC-8BD52E7FFF96}"
+	RootNamespace="libmpcenc"
 	Keyword="Win32Proj"
 	>
@@ -40,5 +41,5 @@
 				Optimization="0"
 				AdditionalIncludeDirectories="../include"
-				PreprocessorDefinitions="_WIN32;WIN32;_DEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE"
+				PreprocessorDefinitions="_WIN32;WIN32;_DEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE;FAST_MATH"
 				ExceptionHandling="0"
 				BasicRuntimeChecks="3"
@@ -105,5 +106,5 @@
 				Name="VCCLCompilerTool"
 				AdditionalIncludeDirectories="../include"
-				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE"
+				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE;FAST_MATH"
 				StringPooling="true"
 				ExceptionHandling="0"
Index: libmpc/trunk/win32/libmpcpsy.vcproj
===================================================================
--- libmpc/trunk/win32/libmpcpsy.vcproj	(revision 342)
+++ libmpc/trunk/win32/libmpcpsy.vcproj	(revision 343)
@@ -2,7 +2,8 @@
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="8,00"
+	Version="8.00"
 	Name="libmpcpsy"
 	ProjectGUID="{7CF31624-B40E-466F-9107-785816C787C4}"
+	RootNamespace="libmpcpsy"
 	Keyword="Win32Proj"
 	>
@@ -40,5 +41,5 @@
 				Optimization="0"
 				AdditionalIncludeDirectories="../include"
-				PreprocessorDefinitions="_WIN32;WIN32;_DEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE"
+				PreprocessorDefinitions="_WIN32;WIN32;_DEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE;FAST_MATH;CVD_FASTLOG"
 				ExceptionHandling="0"
 				BasicRuntimeChecks="3"
@@ -105,5 +106,5 @@
 				Name="VCCLCompilerTool"
 				AdditionalIncludeDirectories="../include"
-				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE"
+				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_LIB;_CRT_SECURE_NO_DEPRECATE;FAST_MATH;CVD_FASTLOG"
 				ExceptionHandling="0"
 				BufferSecurityCheck="false"
Index: libmpc/trunk/win32/mpc2sv8.vcproj
===================================================================
--- libmpc/trunk/win32/mpc2sv8.vcproj	(revision 342)
+++ libmpc/trunk/win32/mpc2sv8.vcproj	(revision 343)
@@ -2,5 +2,5 @@
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="8,00"
+	Version="8.00"
 	Name="mpc2sv8"
 	ProjectGUID="{36225C6A-FFA3-4E70-928E-1F69F7A3FCE1}"
@@ -42,5 +42,5 @@
 				Optimization="0"
 				AdditionalIncludeDirectories="../include;../libmpcenc;../libmpcpsy"
-				PreprocessorDefinitions="_WIN32;WIN32;_DEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE;MPP_ENCODER;CVD_FASTLOG;FAST_MATH"
+				PreprocessorDefinitions="_WIN32;WIN32;_DEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE"
 				ExceptionHandling="0"
 				BasicRuntimeChecks="3"
@@ -125,5 +125,5 @@
 				Name="VCCLCompilerTool"
 				AdditionalIncludeDirectories="../include;../libmpcenc;../libmpcpsy"
-				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE;MPP_ENCODER"
+				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE"
 				ExceptionHandling="0"
 				BufferSecurityCheck="false"
Index: libmpc/trunk/win32/mpccut.vcproj
===================================================================
--- libmpc/trunk/win32/mpccut.vcproj	(revision 342)
+++ libmpc/trunk/win32/mpccut.vcproj	(revision 343)
@@ -2,5 +2,5 @@
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="8,00"
+	Version="8.00"
 	Name="mpccut"
 	ProjectGUID="{ABBF9DD7-650F-48A8-9810-B76F233520F3}"
@@ -42,5 +42,5 @@
 				Optimization="0"
 				AdditionalIncludeDirectories="../include;../libmpcenc;../libmpcpsy;../win32"
-				PreprocessorDefinitions="_WIN32;WIN32;_DEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE;MPP_ENCODER;CVD_FASTLOG;FAST_MATH"
+				PreprocessorDefinitions="_WIN32;WIN32;_DEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE"
 				ExceptionHandling="0"
 				BasicRuntimeChecks="3"
@@ -125,5 +125,5 @@
 				Name="VCCLCompilerTool"
 				AdditionalIncludeDirectories="../include;../libmpcenc;../libmpcpsy;../win32"
-				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE;MPP_ENCODER"
+				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE"
 				ExceptionHandling="0"
 				BufferSecurityCheck="false"
Index: libmpc/trunk/win32/mpcenc.vcproj
===================================================================
--- libmpc/trunk/win32/mpcenc.vcproj	(revision 342)
+++ libmpc/trunk/win32/mpcenc.vcproj	(revision 343)
@@ -2,5 +2,5 @@
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="8,00"
+	Version="8.00"
 	Name="mpcenc"
 	ProjectGUID="{15082E34-9324-469F-8423-F995B4814A37}"
@@ -42,5 +42,5 @@
 				Optimization="0"
 				AdditionalIncludeDirectories="../include;../libmpcenc;../libmpcpsy"
-				PreprocessorDefinitions="_WIN32;WIN32;_DEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE;MPP_ENCODER;CVD_FASTLOG;FAST_MATH"
+				PreprocessorDefinitions="_WIN32;WIN32;_DEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE;FAST_MATH"
 				ExceptionHandling="0"
 				BasicRuntimeChecks="3"
@@ -125,5 +125,5 @@
 				Name="VCCLCompilerTool"
 				AdditionalIncludeDirectories="../include;../libmpcenc;../libmpcpsy"
-				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE;MPP_ENCODER;FAST_MATH;CVD_FASTLOG"
+				PreprocessorDefinitions="_WIN32;WIN32;NDEBUG;_CONSOLE;_CRT_SECURE_NO_DEPRECATE;FAST_MATH"
 				ExceptionHandling="0"
 				BufferSecurityCheck="false"